import socket
import asyncore
import string

# simple demo of the asyncore dispatcher class.

class finger_client (asyncore.dispatcher):
    def __init__ (self, account, done_fun, long=1):
        self.name, self.host = tuple(string.split (account, '@'))
        self.done_fun = done_fun
        self.data = ''
        self.long = long
        self.create_socket (socket.AF_INET, socket.SOCK_STREAM)
        asyncore.dispatcher.__init__ (self)
        self.connect ((host, 79))

	#done_fun is a function that will be called when the finger server has sent all the data and closed the connection. [this programming style - passing functions around that represent an execution path - is called continuation-passing style] The call to create_socket will register the socket with the underlying event mechanism, enabling the following callback procedures. 
    # once connected, send the account name
    def handle_connect (self):
        self.log ('connected')
        if self.long:
            # this requests 'long' output.
            self.send ('/w %s\r\n' % self.name)
        else:
            self.send ('%s\r\n' % self.name)

 	#This function is called when the socket has made a connection. This tells us that we can now send the finger request. 
    # collect some more finger server output.
    def handle_read (self):
        more = self.recv(512)
        if not more:
            self.handle_close()
        self.data = self.data + more

 	#When data is available for reading on the socket, this callback will collect it into the member variable self.data 
    # the other side closed, we're done.
    def handle_close (self):
        print ''
        self.done_fun (self.data)
        self.close()

def demo_done_fun (stuff):
    print stuff

def demo (who='asynfingdemo@squirl.nightmare.com'):
    f = finger_client (who, demo_done_fun, long=0)
    asyncore.loop()
